custom_combat_skills = {}

combat_skill_functions = {}
simple_combat_skills = {}

function register_combat_skill(name, f, auto)
	table.insert(combat_skill_functions, { name = name, f = f, auto = auto })
end

function add_simple_custom_combat_skill(name, list, auto)
	table.insert(simple_combat_skills, { name = name, list = list, auto = auto })
end

if path == "/fight.php" then
	local tbl = get_character_state("proxy.custom skills")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	function list_to_table(list)
		tbl = {}
		for x in string.gmatch(list .. ",", "(.-), *") do
			table.insert(tbl, x)
		end
		return tbl
	end
	for a,b in pairs(tbl) do
		add_simple_custom_combat_skill(b.name, list_to_table(b.list), b.auto)
	end
end

add_printer("/skills.php", function()
	if table_to_str(params) ~= "[]" then return end -- only show if we're looking at the page, not when casting a skill
	helpcontents = {}
	contents = {}
	table.insert(helpcontents, { "Attack", "(built-in, part of KoL)", "" })
	table.insert(helpcontents, { "Pick Pocket", "(built-in, part of KoL)", "" })
	table.insert(helpcontents, { "Jiggle Chefstaff", "(built-in, part of KoL)", "" })
	table.insert(helpcontents, { "{Skill name, e.g. Shieldbutt}", "(built-in, part of KoL)", "" })
	table.insert(helpcontents, { "{Item name, e.g. spices}", "(built-in, part of KoL)", "" })
	for a,b in pairs(combat_skill_functions) do
		table.insert(helpcontents, { b.name, "(scripted)", "" })
	end
	function print_skill_list(list)
		str = ""
		for a,b in pairs(list) do
			if str ~= "" then str = str .. ", " end
			str = str .. b
		end
		return str
	end
	local tbl = get_character_state("proxy.custom skills")
-- 	print("tbl: "..tostring(tbl))
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	had_auto = false
	for a,b in pairs(tbl) do
		if b.list == nil then b.list = "" end
		nametext = "<input type=\"text\" size=\"20\" name=\"custom-skill-name-"..a.."\" value=\""..b.name.."\">"
		listtext = "<input type=\"text\" name=\"custom-skill-list-"..a.."\" size=\"40\" value=\""..b.list.."\">"
		if b.auto == "yes" then
			autotext = "<input type=\"checkbox\" name=\"custom-skill-auto-"..a.."\" value=\"yes\" checked=\"checked\">"
		else
			autotext = "<input type=\"checkbox\" name=\"custom-skill-auto-"..a.."\" value=\"yes\">"
		end
		table.insert(contents, { nametext, listtext, autotext })
		if b.name == "Autoattack" then had_auto = true end
	end
	if had_auto == false then
		table.insert(contents, { "<input type=\"text\" size=\"20\" name=\"custom-skill-name-auto\" value=\"Autoattack\">", "<input type=\"text\" name=\"custom-skill-list-auto\" size=\"40\" value=\"Attack\">", "<input type=\"checkbox\" name=\"custom-skill-auto-auto\" value=\"yes\" checked=\"checked\">" })
	end
	table.insert(contents, { "<input type=\"text\" size=\"20\" name=\"custom-skill-name-new\" value=\"\">", "<input type=\"text\" name=\"custom-skill-list-new\" size=\"40\" value=\"\">", "<input type=\"checkbox\" name=\"custom-skill-auto-new\" value=\"yes\">" })

	contentstr = ""
	for a,b in pairs(contents) do
		contentstr = contentstr .. "<tr><td>"..b[1].."</td><td>=</td><td>"..b[2].."</td><td>"..b[3].."</td></tr>"
	end
	contentstr = "<table>" .. contentstr .. "</table>"

	helpcontentstr = ""
	for a,b in pairs(helpcontents) do
		helpcontentstr = helpcontentstr .. "<tr><td>"..b[1].."</td><td>=</td><td>"..b[2].."</td><td>"..b[3].."</td></tr>"
	end
	helpcontentstr = "<table>" .. helpcontentstr .. "</table>"

	helptext = "<p>This page allows you to create custom combat skills. This works a lot like your normal combat skills, and can be used on the combat bar, but they can be scripted to cast the spells you like.</p>"
	helptext = helptext .. "<p>Here's an example of how this works:<br>"
	helptext = helptext .. "<table><tr><td><input type=\"text\" size=\"20\" value=\"My custom skill\"></td><td>=</td><td><input type=\"text\" size=\"40\" value=\"Entangling Noodles, Shieldbutt\"></td><td><input type=\"checkbox\" checked=\"checked\"></td></tr></table><br>"
	helptext = helptext .. "This creates a custom custom skill called <b>My custom skill</b>, that will cast <b>Entangling Noodles</b> if it can, otherwise cast <b>Shieldbutt</b>, or stop if neither of those skills are available.</p>"
	helptext = helptext .. "<p>The check box means that it will automatically be repeated, otherwise it will only perform one action (like browsing through your skill list to find a skill and use it once, but much faster and easier).</p>"
	helptext = helptext .. "<p>When <b>My custom skill</b> is used in combat, it will first cast noodles, then shieldbutt the monster until you run out of mp. Here's another example:<br>"
	helptext = helptext .. "<table><tr><td><input type=\"text\" size=\"20\" value=\"Opener skill\"></td><td>=</td><td><input type=\"text\" size=\"40\" value=\"Pick Pocket, Entangling Noodles, Insult pirate, Flyer opponent, round{1-5} Shieldbutt\"></td><td><input type=\"checkbox\"></td></tr></table><br>"
	helptext = helptext .. "When <b>Opener skill</b> is used in combat, it will use pick pocket, cast entangling noodles, insult a pirate or flyer the opponent if applicable, and then shieldbutt until combat round 5. If the monster has not died by then, there are no more actions listed and the skill will be disabled.<p>"
	helptext = helptext .. "<p>(<b>Opener skill</b> doesn't have auto-repeat enabled, so it will only perform the listed actions one at a time, so when using this one you can switch to doing something else at any point.)</p>"

	table = "\n<p><center><table width=95%  cellspacing=0 cellpadding=0><tr><td style=\"color: white;\" align=center bgcolor=blue><b>Custom combat skills:</b></td></tr><tr><td style=\"padding: 5px; border: 1px solid blue;\"><center><table><tr><td><center><form action=\"custom-skills\" method=post style='vertical-align: middle'><input type=hidden name=action value=\"set custom skills\">"
	table = table .. "<script language=Javascript src=\"http://images.kingdomofloathing.com/scripts/core.js\"></script>"
	table = table .. "<a href=\"javascript:toggle('custom-builtins');\">(Show available built-in custom skills)</a><br>"
	table = table .. "<div id=\"custom-builtins\" style=\"display: none\">" .. helpcontentstr .. "</div><br>"
	table = table .. "<a href=\"javascript:toggle('custom-help');\">(Show quick help)</a><br>"
	table = table .. "<div id=\"custom-help\" style=\"display: none;\"><div style=\"border: 1px solid black; padding: 5px; margin: 5px\">" .. helptext .. "</div></div><br>"
	table = table .. contentstr
	table = table .. "<input class=button type=submit value=\"Save\"></form></table></center></td></tr></table></center></td></tr><tr><td height=4></td></tr></table></center>"
	table = string.gsub(table, "K&auml;seso&szlig;esturm", "K&amp;auml;seso&amp;szlig;esturm")
	text = text .. table
end)

add_printer("/fight.php", function()
	text = string.gsub(text, "<link rel=\"stylesheet\" type=\"text/css\" href=\"http://images.kingdomofloathing.com/actionbar.[0-9]-.css\">", "%0\n<style type=\"text/css\">.blueback td img[customskill] { border-color: green } .blueback td img[customskill]:hover { border-color: blue } .blueback td img[customskill=\"auto\"] { border-color: goldenrod } .blueback td img[customskill=\"auto\"]:hover { border-color: blue }</style>")
end)

add_printer("/fight.php", function()
	text = string.gsub(text, "http://images.kingdomofloathing.com/(scripts/actionbar.min.[0-9]+.js)", "/images/%1")
end)

add_printer("/scripts/actionbar.min.5.js", function() -- could guess that it will still work in future versions?
	text = string.gsub(text, "var allowedtypes=%[\"action\",\"skill\",\"item\"%];", "%0 button.removeAttribute('customskill');")
	text = string.gsub(text, "button.setAttribute%(\"title\",\"\"%);", "%0 button.removeAttribute('customskill');")
	text = string.gsub(text, "button.setAttribute%(\"title\",action%[\"name\"%]%+extra%);button.className=state.buttonstate%[which%]=\"\";", "%0 if (id.search(/^custom.*skill.*/) != -1) { if (id.search(/^custom autoskill.*/) != -1) { button.setAttribute('customskill', 'auto'); } else { button.setAttribute('customskill', 'yes'); } } else { button.removeAttribute('customskill'); };")
end)
