add_processor("/desc_item.php", function()
	glyph = string.match(text, "title=\"(Arcane Glyph #[0-9]+)\"")
	if glyph then
		tbl = get_ascension_state("zone.manor.glyphs")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		name = string.match(text, "<b>(dusty bottle of [A-Za-z ]+)</b>")
		print(name .. " -> " .. glyph)
		tbl[glyph] = name
		set_ascension_state("zone.manor.glyphs", table_to_str(tbl))
	end
end)

add_printer("/manor3.php", function()
	tbl = get_ascension_state("zone.manor.glyphs")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	prints = {}
	for x in string.gmatch(text, "title=\"(Arcane Glyph #[0-9]+)\"") do
		print("glyph:"..x.." -> "..tostring(tbl[x]))
		table.insert(prints, tostring(tbl[x]))
	end
	text = string.gsub(text, "How curious.", "%0<br><br>"..table.concat(prints, "<br>"))
end)


--~ billiards room

add_choice_text("Minnesota Incorporeals", {
	["Break"] = "Gain moxie",
	["Let the ghost break"] = "<b>Unlock library</b> or gain muscle",
	["Run away"] = "Leave (does not cost an adventure)",
})

add_choice_text("Broken", {
	["Go for a solid"] = "<b>Unlock library</b> or gain mysticality",
	["Go for a stripe"] = "Gain muscle",
	["Go for a walk"] = "Leave (does not cost an adventure)",
})

add_choice_text("A Hustle Here, a Hustle There", {
	["Go for the 8%-ball"] = "<b>Unlock library</b> (with Chalky Hand active)",
	["Play defensively"] = "Gain mysticality",
	["Chicken out"] = "Leave (does not cost an adventure)",
})


-- library

add_choice_text("Take a Look, it's in a Book!", {
	["Read &quot;The Rise of the House of Spookyraven&quot;"] = "Read stories...",
	["Read &quot;The Better Haunted Homes and Conservatories Cookbook&quot;"] = "Get a random cooking recipe",
	["Read &quot;Ancient Forbidden Unspeakable Evil, a Love Story&quot;"] = "Gain myst or mox or myst spookyraven skill...",
	["Reading is for losers.  I'm outta here."] = "Leave (does not cost an adventure)",

	["Read &quot;The Fall of the House of Spookyraven&quot;"] = "Unlock tombstone adventure...",
	["Read &quot;To Serve Man... Delicious Cocktails&quot;"] = "Get a random mixing recipe",
	["Read &quot;Ancient Forbidden Unspeakable Yoga, a Beginner's Guide&quot;"] = "Gain muscle and take damage",
})

add_choice_text("Naughty, Naughty...", {
	["Read Chapter 1:  Tuesdays with Abhorrent Fiends"] = "Gain myst",
	["Read Chapter 2:  The Nether Planes on 350 Meat a Day"] = "Gain mox",
	["Read Chapter 3:  Twisted, Curdled, Corrupt Energy and You"] = "Gain myst spookyraven skill or take damage",
})

-- bathroom

add_choice_text("Having a Medicine Ball", {
	["Gaze deeply into the mirror"] = "Gain myst",
})

add_choice_text("Don't Hold a Grudge", {
	["Declare a thumb war"] = "Gain myst",
})

-- bedroom

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Get coin purse",
	["Check the bottom drawer"] = "Fight nightstand",
	["Look under the nightstand"] = "Spookyraven skill item",
}, function() return string.match(text, "mahogany") end)

add_choice_text_conditional("One Nightstand", {
	["Open the top drawer"] = "Gain meat",
	["Open the bottom drawer"] = "Gain myst",
	["Look behind the nightstand"] = "Get spectacles",
}, function() return string.match(text, "ornately") end)

add_choice_text_conditional("One Nightstand", {
	["Look in the top drawer"] = "Get wallet",
	["Look in the bottom drawer"] = "Gain muscle",
	["Kick it and see what happens"] = "Fight nightstand",
}, function() return string.match(text, "white") end)

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Gain mox + unlock key",
	["Check the bottom drawer"] = "Gain ballroom key",
	["Investigate the jewelry"] = "Fight mistress",
}, function() return string.match(text, "wooden") end)

-- ballroom

add_choice_text("Strung-Up Quartet", {
	["&quot;Play 'Provare Compasione Per El Sciocco'&quot;"] = "Set song to +5 ML",
	["&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;"] = "Set song to +5%% non-combats",
	["&quot;Play 'Le Mie Cose Favorite'&quot;"] = "Set song to +5%% items",
	["&quot;Play nothing, please.&quot;"] = "Disable song",
})
